=== debian/changelog ===
vvdec-dmo (1.1.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 07 Jul 2021 23:22:09 +0200

vvdec-dmo (1.1.1-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 02 Jul 2021 15:51:02 +0200
